Index: graph_displayer_canvas.cc
===================================================================
--- graph_displayer_canvas.cc	(revision 201)
+++ graph_displayer_canvas.cc	(revision 187)
@@ -17,13 +17,11 @@
  */
 
-#include <mapstorage.h>
-#include <nbtab.h>
-#include <graph_displayer_canvas.h>
+#include "graph_displayer_canvas.h"
 #include <lemon/random.h>
 #include <cmath>
 
 GraphDisplayerCanvas::GraphDisplayerCanvas(NoteBookTab & mainw) :
-  nodesmap(mainw.mapstorage->graph), edgesmap(mainw.mapstorage->graph), edgetextmap(mainw.mapstorage->graph),
-  nodetextmap(mainw.mapstorage->graph), displayed_graph(*(root()), 0, 0),
+  nodesmap(mainw.mapstorage.graph), edgesmap(mainw.mapstorage.graph), edgetextmap(mainw.mapstorage.graph),
+  nodetextmap(mainw.mapstorage.graph), displayed_graph(*(root()), 0, 0),
   isbutton(0), active_item(NULL), target_item(NULL), nodemap_to_edit(""),
   edgemap_to_edit(""), autoscale(true), zoomtrack(false), radius_size(20), edge_width(10),
@@ -52,9 +50,9 @@
     delete background;
   }
-  if (mytab.mapstorage->isBackgroundSet())
+  if (mytab.mapstorage.isBackgroundSet())
   {
     background_set = true;
     refBackground = Gdk::Pixbuf::create_from_file(
-      mytab.mapstorage->getBackgroundFilename());
+      mytab.mapstorage.getBackgroundFilename());
     background = new Gnome::Canvas::Pixbuf(
         *(root()),
@@ -72,5 +70,5 @@
 GraphDisplayerCanvas::~GraphDisplayerCanvas()
 {
-  for (NodeIt n((mytab.mapstorage)->graph); n != INVALID; ++n)
+  for (NodeIt n((mytab.mapstorage).graph); n != INVALID; ++n)
     {
       delete nodesmap[n];
@@ -78,5 +76,5 @@
     }
   
-  for (EdgeIt e((mytab.mapstorage)->graph); e != INVALID; ++e)
+  for (EdgeIt e((mytab.mapstorage).graph); e != INVALID; ++e)
     {
       delete edgesmap[e];
@@ -118,55 +116,44 @@
 
   if(is_drawn)
-  {
-    if(mapname!="")
-    {
-      std::vector<std::string> nodemaps = mytab.mapstorage->getNodeMapList();
-      bool found = false;
-      for (std::vector<std::string>::const_iterator it = nodemaps.begin();
-          it != nodemaps.end(); ++it)
-      {
-        if (*it == mapname)
-        {
-          found = true;
-          break;
-        }
-      }
-      if (found)
-      {
-        switch(prop)
-        {
-          case N_RADIUS:
-            changeNodeRadius(mapname, node);
-            break;
-          case N_COLOR:
-            changeNodeColor(mapname, node);
-            break;
-          case N_TEXT:
-            changeNodeText(mapname, node);
-            break;
-          default:
-            std::cerr<<"Error\n";
-        }
-      }
-    }
-    else //mapname==""
-    {
-      Node node=INVALID;
-      switch(prop)
-      {
-        case N_RADIUS:
-          resetNodeRadius(node);
-          break;
-        case N_COLOR:
-          resetNodeColor(node);
-          break;
-        case N_TEXT:
-          resetNodeText(node);
-          break;
-        default:
-          std::cerr<<"Error\n";
-      }
-    }
-  }
+    {
+      if(mapname!="")
+	{
+	  if( ( ((mytab.mapstorage).nodemap_storage).find(mapname) != ((mytab.mapstorage).nodemap_storage).end() ) )
+	    {
+	      switch(prop)
+		{
+		case N_RADIUS:
+		  changeNodeRadius(mapname, node);
+		  break;
+		case N_COLOR:
+		  changeNodeColor(mapname, node);
+		  break;
+		case N_TEXT:
+		  changeNodeText(mapname, node);
+		  break;
+		default:
+		  std::cerr<<"Error\n";
+		}
+	    }
+	}
+      else //mapname==""
+	{
+	  Node node=INVALID;	
+	  switch(prop)
+	    {
+	    case N_RADIUS:
+	      resetNodeRadius(node);
+	      break;
+	    case N_COLOR:
+	      resetNodeColor(node);
+	      break;
+	    case N_TEXT:
+	      resetNodeText(node);
+	      break;
+	    default:
+	      std::cerr<<"Error\n";
+	    }
+	}
+    }
 }
 
@@ -176,54 +163,43 @@
 
   if(is_drawn)
-  {
-    if(mapname!="")
-    {
-      std::vector<std::string> edgemaps = mytab.mapstorage->getEdgeMapList();
-      bool found = false;
-      for (std::vector<std::string>::const_iterator it = edgemaps.begin();
-          it != edgemaps.end(); ++it)
-      {
-        if (*it == mapname)
-        {
-          found = true;
-          break;
-        }
-      }
-      if (found)
-      {
-        switch(prop)
-        {
-          case E_WIDTH:
-            changeEdgeWidth(mapname, edge);
-            break;
-          case E_COLOR:
-            changeEdgeColor(mapname, edge);
-            break;
-          case E_TEXT:
-            changeEdgeText(mapname, edge);
-            break;
-          default:
-            std::cerr<<"Error\n";
-        }
-      }
-    }
-    else //mapname==""
-    {
-      switch(prop)
-      {
-        case E_WIDTH:
-          resetEdgeWidth(edge);
-          break;
-        case E_COLOR:
-          resetEdgeColor(edge);
-          break;
-        case E_TEXT:
-          resetEdgeText(edge);
-          break;
-        default:
-          std::cerr<<"Error\n";
-      }
-    }
-  }
+    {
+      if(mapname!="")
+	{
+	  if( ( ((mytab.mapstorage).edgemap_storage).find(mapname) != ((mytab.mapstorage).edgemap_storage).end() ) )
+	    {
+	      switch(prop)
+		{
+		case E_WIDTH:
+		  changeEdgeWidth(mapname, edge);
+		  break;
+		case E_COLOR:
+		  changeEdgeColor(mapname, edge);
+		  break;
+		case E_TEXT:
+		  changeEdgeText(mapname, edge);
+		  break;
+		default:
+		  std::cerr<<"Error\n";
+		}
+	    }
+	}
+      else //mapname==""
+	{
+	  switch(prop)
+	    {
+	    case E_WIDTH:
+	      resetEdgeWidth(edge);
+	      break;
+	    case E_COLOR:
+	      resetEdgeColor(edge);
+	      break;
+	    case E_TEXT:
+	      resetEdgeText(edge);
+	      break;
+	    default:
+	      std::cerr<<"Error\n";
+	    }
+	}
+    }
 }
 
@@ -232,7 +208,7 @@
   //first edges are drawn, to hide joining with nodes later
 
-  for (EdgeIt i((mytab.mapstorage)->graph); i!=INVALID; ++i)
-  {
-    if (mytab.mapstorage->graph.source(i) == mytab.mapstorage->graph.target(i))
+  for (EdgeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
+  {
+    if (mytab.mapstorage.graph.source(i) == mytab.mapstorage.graph.target(i))
     {
       edgesmap[i]=new LoopEdge(displayed_graph, i, *this);
@@ -244,5 +220,5 @@
     //initializing edge-text as well, to empty string
 
-    XY text_pos=mytab.mapstorage->getArrowCoords(i);
+    XY text_pos=mytab.mapstorage.arrow_pos[i];
     text_pos+=(XY(10,10));
 
@@ -255,5 +231,5 @@
   //afterwards nodes come to be drawn
 
-  for (NodeIt i((mytab.mapstorage)->graph); i!=INVALID; ++i)
+  for (NodeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
   {
     //drawing bule nodes, with black line around them
@@ -261,8 +237,8 @@
     nodesmap[i]=new Gnome::Canvas::Ellipse(
         displayed_graph,
-        mytab.mapstorage->getNodeCoords(i).x-20,
-        mytab.mapstorage->getNodeCoords(i).y-20,
-        mytab.mapstorage->getNodeCoords(i).x+20,
-        mytab.mapstorage->getNodeCoords(i).y+20);
+        (mytab.mapstorage).coords[i].x-20,
+        (mytab.mapstorage).coords[i].y-20,
+        (mytab.mapstorage).coords[i].x+20,
+        (mytab.mapstorage).coords[i].y+20);
     *(nodesmap[i]) << Gnome::Canvas::Properties::fill_color("blue");
     *(nodesmap[i]) << Gnome::Canvas::Properties::outline_color("black");
@@ -272,6 +248,6 @@
 
     XY text_pos(
-        (mytab.mapstorage->getNodeCoords(i).x+node_property_defaults[N_RADIUS]+5),
-        (mytab.mapstorage->getNodeCoords(i).y+node_property_defaults[N_RADIUS]+5));
+        ((mytab.mapstorage).coords[i].x+node_property_defaults[N_RADIUS]+5),
+        ((mytab.mapstorage).coords[i].y+node_property_defaults[N_RADIUS]+5));
 
     nodetextmap[i]=new Gnome::Canvas::Text(displayed_graph,
@@ -306,5 +282,5 @@
   forming_edge=INVALID;
 
-  for (NodeIt n((mytab.mapstorage)->graph); n != INVALID; ++n)
+  for (NodeIt n((mytab.mapstorage).graph); n != INVALID; ++n)
   {
     delete nodesmap[n];
@@ -312,5 +288,5 @@
   }
 
-  for (EdgeIt e((mytab.mapstorage)->graph); e != INVALID; ++e)
+  for (EdgeIt e((mytab.mapstorage).graph); e != INVALID; ++e)
   {
     delete edgesmap[e];
@@ -348,114 +324,110 @@
 void GraphDisplayerCanvas::reDesignGraph()
 {
-  MapStorage& ms = *mytab.mapstorage;
-  NodeIt firstnode(ms.graph);
-  //is it not an empty graph?
-  if(firstnode!=INVALID)
-    {
-      double max_coord=50000;
-      double min_dist=20;
-      double init_vector_length=25;
-
-      if(!was_redesigned)
-	{
-	  NodeIt i(ms.graph);
-
-	  dim2::Point<double> init(init_vector_length*rnd(),
-				   init_vector_length*rnd());
-	  moveNode(init.x, init.y, nodesmap[i], i);
-	  was_redesigned=true;
-	}
-
-      double attraction;
-      double propulsation;
-      int iterations;
-
-      ms.get_design_data(attraction, propulsation, iterations);
-
-      //iteration counter
-      for(int l=0;l<iterations;l++)
-	{
-	  Graph::NodeMap<double> x(ms.graph);
-	  Graph::NodeMap<double> y(ms.graph);
-	  XYMap<Graph::NodeMap<double> > actual_forces;
-	  actual_forces.setXMap(x);
-	  actual_forces.setYMap(y);
-
-	  //count actual force for each nodes
-	  for (NodeIt i(ms.graph); i!=INVALID; ++i)
-	    {
-	      //propulsation of nodes
-	      for (NodeIt j(ms.graph); j!=INVALID; ++j)
+  double max_coord=50000;
+  double min_dist=20;
+  double init_vector_length=25;
+
+  if(!was_redesigned)
+    {
+      NodeIt i((mytab.mapstorage).graph);
+
+      dim2::Point<double> init(init_vector_length*rnd(),
+			       init_vector_length*rnd());
+      moveNode(init.x, init.y, nodesmap[i], i);
+      was_redesigned=true;
+    }
+
+  double attraction;
+  double propulsation;
+  int iterations;
+
+  (mytab.mapstorage).get_design_data(attraction, propulsation, iterations);
+
+  //iteration counter
+  for(int l=0;l<iterations;l++)
+    {
+      Graph::NodeMap<double> x(mytab.mapstorage.graph);
+      Graph::NodeMap<double> y(mytab.mapstorage.graph);
+      XYMap<Graph::NodeMap<double> > actual_forces;
+      actual_forces.setXMap(x);
+      actual_forces.setYMap(y);
+
+      //count actual force for each nodes
+      for (NodeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
+	{
+	  //propulsation of nodes
+	  for (NodeIt j((mytab.mapstorage).graph); j!=INVALID; ++j)
+	    {
+	      if(i!=j)
 		{
-		  if(i!=j)
-		    {
-		      lemon::dim2::Point<double> delta =
-			(ms.getNodeCoords(i)-
-			 ms.getNodeCoords(j));
-
-		      const double length_sqr=std::max(delta.normSquare(),min_dist);
-
-		      //normalize vector
-		      delta/=sqrt(length_sqr);
-
-		      //calculating propulsation strength
-		      //greater distance menas smaller propulsation strength
-		      delta*=propulsation/length_sqr;
+		  lemon::dim2::Point<double> delta =
+		    ((mytab.mapstorage).coords[i]-
+		     (mytab.mapstorage).coords[j]);
+
+		  const double length_sqr=std::max(delta.normSquare(),min_dist);
+
+		  //normalize vector
+		  delta/=sqrt(length_sqr);
+
+		  //calculating propulsation strength
+		  //greater distance menas smaller propulsation strength
+		  delta*=propulsation/length_sqr;
 		    
-		      actual_forces.set(i,(actual_forces[i]+delta));
-		    }
+		  actual_forces.set(i,(actual_forces[i]+delta));
 		}
-            //attraction of nodes, to which actual node is bound
-            for(OutEdgeIt ei(ms.graph,i);ei!=INVALID;++ei)
-              {
-                lemon::dim2::Point<double> delta =
-                  (ms.getNodeCoords(i)-
-                   ms.getNodeCoords(ms.graph.target(ei)));
-
-                //calculating attraction strength
-                //greater distance means greater strength
-                delta*=attraction;
-
-                actual_forces.set(i,actual_forces[i]-delta);
-              }
-                    for(InEdgeIt ei(ms.graph,i);ei!=INVALID;++ei)
-              {
-                lemon::dim2::Point<double> delta =
-                  (ms.getNodeCoords(i)-
-                   ms.getNodeCoords(ms.graph.source(ei)));
-
-                //calculating attraction strength
-                //greater distance means greater strength
-                delta*=attraction;
-
-                actual_forces.set(i,actual_forces[i]-delta);
-              }
-	    }
-	  for (NodeIt i(ms.graph); i!=INVALID; ++i)
-	    {
-	      if((ms.getNodeCoords(i).x)+actual_forces[i].x>max_coord)
-		{
-		  actual_forces[i].x=max_coord-(ms.getNodeCoords(i).x);
-		  std::cout << "Correction! " << ((ms.getNodeCoords(i).x)+actual_forces[i].x) << std::endl;
-		}
-	      else if((ms.getNodeCoords(i).x)+actual_forces[i].x<(0-max_coord))
-		{
-		  actual_forces[i].x=0-max_coord-(ms.getNodeCoords(i).x);
-		  std::cout << "Correction! " << ((ms.getNodeCoords(i).x)+actual_forces[i].x) << std::endl;
-		}
-	      if((ms.getNodeCoords(i).y)+actual_forces[i].y>max_coord)
-		{
-		  actual_forces[i].y=max_coord-(ms.getNodeCoords(i).y);
-		  std::cout << "Correction! " << ((ms.getNodeCoords(i).y)+actual_forces[i].y) << std::endl;
-		}
-	      else if((ms.getNodeCoords(i).y)+actual_forces[i].y<(0-max_coord))
-		{
-		  actual_forces[i].y=0-max_coord-(ms.getNodeCoords(i).y);
-		  std::cout << "Correction! " << ((ms.getNodeCoords(i).y)+actual_forces[i].y) << std::endl;
-		}
-	      moveNode(actual_forces[i].x, actual_forces[i].y, nodesmap[i], i);
-	    }
-	}
-    }
-}
-
+	    }
+	  //attraction of nodes, to which actual node is bound
+	  for(OutEdgeIt ei((mytab.mapstorage).graph,i);ei!=INVALID;++ei)
+	    {
+	      lemon::dim2::Point<double> delta =
+		((mytab.mapstorage).coords[i]-
+		 (mytab.mapstorage).coords[mytab.mapstorage.
+					   graph.target(ei)]);
+		
+		//calculating attraction strength
+		//greater distance means greater strength
+		delta*=attraction;
+		
+		actual_forces.set(i,actual_forces[i]-delta);
+	    }
+	  for(InEdgeIt ei((mytab.mapstorage).graph,i);ei!=INVALID;++ei)
+	    {
+	      lemon::dim2::Point<double> delta =
+		((mytab.mapstorage).coords[i]-
+		 (mytab.mapstorage).coords[mytab.mapstorage.
+					   graph.source(ei)]);
+		
+		//calculating attraction strength
+		//greater distance means greater strength
+		delta*=attraction;
+		
+		actual_forces.set(i,actual_forces[i]-delta);
+	    }
+	}
+      for (NodeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
+	{
+	  if(((mytab.mapstorage).coords[i].x)+actual_forces[i].x>max_coord)
+	    {
+	      actual_forces[i].x=max_coord-((mytab.mapstorage).coords[i].x);
+	      std::cout << "Correction! " << (((mytab.mapstorage).coords[i].x)+actual_forces[i].x) << std::endl;
+	    }
+	  else if(((mytab.mapstorage).coords[i].x)+actual_forces[i].x<(0-max_coord))
+	    {
+	      actual_forces[i].x=0-max_coord-((mytab.mapstorage).coords[i].x);
+	      std::cout << "Correction! " << (((mytab.mapstorage).coords[i].x)+actual_forces[i].x) << std::endl;
+	    }
+	  if(((mytab.mapstorage).coords[i].y)+actual_forces[i].y>max_coord)
+	    {
+	      actual_forces[i].y=max_coord-((mytab.mapstorage).coords[i].y);
+	      std::cout << "Correction! " << (((mytab.mapstorage).coords[i].y)+actual_forces[i].y) << std::endl;
+	    }
+	  else if(((mytab.mapstorage).coords[i].y)+actual_forces[i].y<(0-max_coord))
+	    {
+	      actual_forces[i].y=0-max_coord-((mytab.mapstorage).coords[i].y);
+	      std::cout << "Correction! " << (((mytab.mapstorage).coords[i].y)+actual_forces[i].y) << std::endl;
+	    }
+	  moveNode(actual_forces[i].x, actual_forces[i].y, nodesmap[i], i);
+	}
+    }
+}
+
Index: graph_displayer_canvas.h
===================================================================
--- graph_displayer_canvas.h	(revision 194)
+++ graph_displayer_canvas.h	(revision 187)
@@ -20,9 +20,11 @@
 #define GRAPH_DISPLAYER_CANVAS_H
 
-class NoteBookTab;
+class GraphDisplayerCanvas;
 
 #include "all_include.h"
+#include "nbtab.h"
 #include <libgnomecanvasmm.h>
 #include <libgnomecanvasmm/polygon.h>
+#include <lemon/dim2.h>
 
 ///This class is the canvas, on which the graph can be drawn.
Index: gui_reader.cc
===================================================================
--- gui_reader.cc	(revision 201)
+++ gui_reader.cc	(revision 177)
@@ -17,9 +17,7 @@
  */
 
-#include <gui_reader.h>
-#include <mapstorage.h>
-
-#include <xml.h>
-#include "io_helper.h"
+#include "gui_reader.h"
+#include "xml.h"
+#include "mapstorage.h"
 #include <lemon/dim2.h>
 #include <vector>
@@ -35,137 +33,32 @@
 void GuiReader::read(std::istream& is)
 {
-  using std::vector;
-  using std::string;
-  using std::pair;
-  using std::make_pair;
-  using std::string;
-  using std::map;
+  XmlIo x(is);
+  std::map<int, XY > m;
+  x("arrow_pos", m);
 
-  XmlIo x(is);
-
-  { x("main_node_map_names", gui_data.main_node_map_names); }
-  { x("gui_node_map_names", gui_data.gui_node_map_names); }
-
-  { x("node_map_types", gui_data.node_map_types); }
-
-  { x("main_edge_map_names", gui_data.main_edge_map_names); }
-  { x("gui_edge_map_names", gui_data.gui_edge_map_names); }
-
-  { x("edge_map_types", gui_data.edge_map_types); }
-
-  for (vector<string>::const_iterator it = gui_data.gui_node_map_names.begin();
-      it != gui_data.gui_node_map_names.end(); ++it)
-  {
-    MapValue::Type type = gui_data.node_map_types[*it];
-    switch (type)
+  if ((int)m.size() == countEdges(mapstorage->graph))
     {
-      case MapValue::NUMERIC:
-        {
-          map<int, double>* p_map_data =
-            new map<int, double>;
-          gui_data.numeric_node_maps[*it] = p_map_data;
-          { x(*it, *p_map_data); }
-        }
-        break;
-      case MapValue::STRING:
-        {
-          map<int, string>* p_map_data =
-            new map<int, string>;
-          gui_data.string_node_maps[*it] = p_map_data;
-          { x(*it, *p_map_data); }
-        }
-        break;
+      for (EdgeIt e(mapstorage->graph); e != INVALID; ++e)
+	{
+	  int edgeid = (int)(*mapstorage->edgemap_storage["label"])[e];
+	  mapstorage->arrow_pos.set(e, m[edgeid]);
+	}
+      mapstorage->ArrowPosReadOK();
     }
-  }
-
-  for (vector<string>::const_iterator it = gui_data.gui_edge_map_names.begin();
-      it != gui_data.gui_edge_map_names.end(); ++it)
-  {
-    MapValue::Type type = gui_data.edge_map_types[*it];
-    switch (type)
-    {
-      case MapValue::NUMERIC:
-        {
-          map<int, double>* p_map_data =
-            new map<int, double>;
-          gui_data.numeric_edge_maps[*it] = p_map_data;
-          { x(*it, *p_map_data); }
-        }
-        break;
-      case MapValue::STRING:
-        {
-          map<int, string>* p_map_data =
-            new map<int, string>;
-          gui_data.string_edge_maps[*it] = p_map_data;
-          { x(*it, *p_map_data); }
-        }
-        break;
-    }
-  }
-
-  {
-    std::string node_coords_save_dest;
-    { x("node_coords_save_dest", node_coords_save_dest); }
-    if (node_coords_save_dest == "gui_sect")
-    {
-      // read the node coorinates
-      gui_data.node_coords_save_dest = MapStorage::SpecMapSaveOpts::GUI_SECT;
-      { x("node_coord_map", gui_data.node_coord_map); }
-    }
-    else if (node_coords_save_dest == "nodeset_sect_1_map")
-    {
-      gui_data.node_coords_save_dest = MapStorage::SpecMapSaveOpts::NESET_SECT;
-      gui_data.node_coords_save_map_num = MapStorage::SpecMapSaveOpts::ONE_MAP;
-      { x("map_name", gui_data.node_coords_one_map_name); }
-    }
-    else if (node_coords_save_dest == "nodeset_sect_2_maps")
-    {
-      gui_data.node_coords_save_dest = MapStorage::SpecMapSaveOpts::NESET_SECT;
-      gui_data.node_coords_save_map_num = MapStorage::SpecMapSaveOpts::TWO_MAPS;
-      { x("map1_name", gui_data.node_coords_two_maps_1_name); }
-      { x("map2_name", gui_data.node_coords_two_maps_2_name); }
-    }
-  }
-
-  {
-    std::string arrow_coords_save_dest;
-    { x("arrow_coords_save_dest", arrow_coords_save_dest); }
-    if (arrow_coords_save_dest == "gui_sect")
-    {
-      // read the arrow coorinates
-      gui_data.arrow_coords_save_dest = MapStorage::SpecMapSaveOpts::GUI_SECT;
-      { x("arrow_coord_map", gui_data.arrow_coord_map); }
-    }
-    else if (arrow_coords_save_dest == "edgeset_sect_1_map")
-    {
-      gui_data.arrow_coords_save_dest = MapStorage::SpecMapSaveOpts::NESET_SECT;
-      gui_data.arrow_coords_save_map_num = MapStorage::SpecMapSaveOpts::ONE_MAP;
-      { x("map_name", gui_data.arrow_coords_one_map_name); }
-    }
-    else if (arrow_coords_save_dest == "edgeset_sect_2_maps")
-    {
-      gui_data.arrow_coords_save_dest = MapStorage::SpecMapSaveOpts::NESET_SECT;
-      gui_data.arrow_coords_save_map_num = MapStorage::SpecMapSaveOpts::TWO_MAPS;
-      { x("map1_name", gui_data.arrow_coords_two_maps_1_name); }
-      { x("map2_name", gui_data.arrow_coords_two_maps_2_name); }
-    }
-  }
-
-
-
+  
   std::map<int, std::string> nm;
   x("active_nodemaps", nm);
 
   for(int i=0;i<NODE_PROPERTY_NUM;i++)
-  {
-    mapstorage->changeActiveMap(false, i, nm[i]);
-  }
+    {
+      mapstorage->changeActiveMap(false, i, nm[i]);
+    }
 
   std::map<int, std::string> em;
   x("active_edgemaps", em);
   for(int i=0;i<EDGE_PROPERTY_NUM;i++)
-  {
-    mapstorage->changeActiveMap(true, i, em[i]);
-  }
+    {
+      mapstorage->changeActiveMap(true, i, em[i]);
+    }
 
   double attraction;
@@ -184,9 +77,5 @@
 }
 
-GuiReader::GuiReader(LemonReader& reader, MapStorage* _mapstorage,
-    MapStorage::GUISectData& _gui_data) :
-  Parent(reader),
-  mapstorage(_mapstorage),
-  gui_data(_gui_data)
+GuiReader::GuiReader(LemonReader& reader, MapStorage* ms) : Parent(reader), mapstorage(ms)
 {
 }
Index: gui_reader.h
===================================================================
--- gui_reader.h	(revision 201)
+++ gui_reader.h	(revision 174)
@@ -19,7 +19,7 @@
 #ifndef GUI_READER_H
 #define GUI_READER_H
-#include <lemon/lemon_reader.h>
 
 #include "mapstorage.h"
+#include <lemon/lemon_reader.h>
 
 using lemon::LemonReader;
@@ -29,5 +29,4 @@
   private:
     MapStorage* mapstorage;
-    MapStorage::GUISectData& gui_data;
   protected:
     virtual bool header(const std::string&);
@@ -35,5 +34,5 @@
   public:
     typedef LemonReader::SectionReader Parent;
-    GuiReader(LemonReader&, MapStorage*, MapStorage::GUISectData&);
+    GuiReader(LemonReader&, MapStorage*);
 };
 
Index: gui_writer.cc
===================================================================
--- gui_writer.cc	(revision 201)
+++ gui_writer.cc	(revision 177)
@@ -18,12 +18,8 @@
 
 #include "gui_writer.h"
-#include "io_helper.h"
+#include "xml.h"
 #include "mapstorage.h"
-#include "xml.h"
 #include <lemon/dim2.h>
 #include <vector>
-
-#include <gui_writer.h>
-#include <mapstorage.h>
 
 std::string GuiWriter::header()
@@ -34,216 +30,12 @@
 void GuiWriter::write(std::ostream& os)
 {
-  using std::vector;
-  using std::string;
-  using std::map;
-  using std::string;
-
   XmlIo x(os);
-
-  vector<string> all_node_map_names = mapstorage->getNodeMapList();
-  // name of the maps saved to the nodeset section
-  vector<string> main_node_map_names;
-  // name of the maps saved to the gui section
-  vector<string> gui_node_map_names;
-
-  for (vector<string>::const_iterator it = all_node_map_names.begin();
-      it != all_node_map_names.end(); ++it)
+  std::map<int, XY > m;
+  for (EdgeIt e(mapstorage->graph); e != INVALID; ++e)
   {
-    if (mapstorage->getNodeMapSaveDest(*it) == MapStorage::NESET_SECT)
-      main_node_map_names.push_back(*it);
-    else if (mapstorage->getNodeMapSaveDest(*it) == MapStorage::GUI_SECT)
-      gui_node_map_names.push_back(*it);
+    int edgeid = (int)(*(mapstorage->edgemap_storage["label"]))[e];
+    m[edgeid] = mapstorage->arrow_pos[e];
   }
-
-  { x("main_node_map_names", main_node_map_names); }
-  { x("gui_node_map_names", gui_node_map_names); }
-
-  map<string, MapValue::Type> node_map_types;
-  for (vector<string>::const_iterator it = main_node_map_names.begin();
-      it != main_node_map_names.end(); ++it)
-  {
-    node_map_types[*it] = mapstorage->getNodeMapElementType(*it);
-  }
-  for (vector<string>::const_iterator it = gui_node_map_names.begin();
-      it != gui_node_map_names.end(); ++it)
-  {
-    node_map_types[*it] = mapstorage->getNodeMapElementType(*it);
-  }
-
-  { x("node_map_types", node_map_types); }
-
-
-  vector<string> all_edge_map_names = mapstorage->getEdgeMapList();
-  // name of the maps saved to the edgeset section
-  vector<string> main_edge_map_names;
-  // name of the maps saved to the gui section
-  vector<string> gui_edge_map_names;
-
-  for (vector<string>::const_iterator it = all_edge_map_names.begin();
-      it != all_edge_map_names.end(); ++it)
-  {
-    if (mapstorage->getEdgeMapSaveDest(*it) == MapStorage::NESET_SECT)
-      main_edge_map_names.push_back(*it);
-    if (mapstorage->getEdgeMapSaveDest(*it) == MapStorage::GUI_SECT)
-      gui_edge_map_names.push_back(*it);
-  }
-
-  { x("main_edge_map_names", main_edge_map_names); }
-  { x("gui_edge_map_names", gui_edge_map_names); }
-
-  map<string, MapValue::Type> edge_map_types;
-  for (vector<string>::const_iterator it = main_edge_map_names.begin();
-      it != main_edge_map_names.end(); ++it)
-  {
-    edge_map_types[*it] = mapstorage->getEdgeMapElementType(*it);
-  }
-  for (vector<string>::const_iterator it = gui_edge_map_names.begin();
-      it != gui_edge_map_names.end(); ++it)
-  {
-    edge_map_types[*it] = mapstorage->getEdgeMapElementType(*it);
-  }
-
-  { x("edge_map_types", edge_map_types); }
-
-  // write the gui node maps
-  for (vector<string>::const_iterator it = gui_node_map_names.begin();
-      it != gui_node_map_names.end(); ++it)
-  {
-    MapValue::Type type = mapstorage->getNodeMapElementType(*it);
-    const MapStorage::NodeLabelMap& labels = mapstorage->getNodeLabelMap();
-    switch (type)
-    {
-      case MapValue::NUMERIC:
-        {
-          std::map<int, double> map_data;
-          MapStorage::NumericNodeMap& map =
-            mapstorage->getNumericNodeMap(*it);
-          for (NodeIt n(mapstorage->getGraph()); n != INVALID; ++n)
-          {
-            map_data[labels[n]] = map[n];
-          }
-          { x(*it, map_data); }
-        }
-        break;
-      case MapValue::STRING:
-        {
-          std::map<int, std::string> map_data;
-          MapStorage::StringNodeMap& map =
-            mapstorage->getStringNodeMap(*it);
-          for (NodeIt n(mapstorage->getGraph()); n != INVALID; ++n)
-          {
-            map_data[labels[n]] = map[n];
-          }
-          { x(*it, map_data); }
-        }
-        break;
-    }
-  }
-
-  // write the gui edge maps
-  for (vector<string>::const_iterator it = gui_edge_map_names.begin();
-      it != gui_edge_map_names.end(); ++it)
-  {
-    MapValue::Type type = mapstorage->getEdgeMapElementType(*it);
-    const MapStorage::EdgeLabelMap& labels = mapstorage->getEdgeLabelMap();
-    switch (type)
-    {
-      case MapValue::NUMERIC:
-        {
-          std::map<int, double> map_data;
-          MapStorage::NumericEdgeMap& map =
-            mapstorage->getNumericEdgeMap(*it);
-          for (EdgeIt e(mapstorage->getGraph()); e != INVALID; ++e)
-          {
-            map_data[labels[e]] = map[e];
-          }
-          { x(*it, map_data); }
-        }
-        break;
-      case MapValue::STRING:
-        {
-          std::map<int, std::string> map_data;
-          MapStorage::StringEdgeMap& map =
-            mapstorage->getStringEdgeMap(*it);
-          for (EdgeIt e(mapstorage->getGraph()); e != INVALID; ++e)
-          {
-            map_data[labels[e]] = map[e];
-          }
-          { x(*it, map_data); }
-        }
-        break;
-    }
-  }
-
-  {
-    switch (mapstorage->getNodeCoordsSaveDest())
-    {
-      case MapStorage::SpecMapSaveOpts::GUI_SECT:
-        { x("node_coords_save_dest", string("gui_sect")); }
-        // write the node coorinates
-        {
-          const MapStorage::NodeLabelMap& labels =
-            mapstorage->getNodeLabelMap();
-          std::map<int, XY> node_coord_map;
-          MapStorage::NodeCoordMap& map = mapstorage->getNodeCoordMap();
-          for (NodeIt n(mapstorage->getGraph()); n != INVALID; ++n)
-          {
-            node_coord_map[labels[n]] = map[n];
-          }
-          { x("node_coord_map", node_coord_map); }
-        }
-        break;
-      case MapStorage::SpecMapSaveOpts::NESET_SECT:
-        switch (mapstorage->getNodeCoordsSaveMapNum())
-        {
-          case MapStorage::SpecMapSaveOpts::ONE_MAP:
-            { x("node_coords_save_dest", string("nodeset_sect_1_map")); }
-            { x("map_name", mapstorage->getNodeCoordsOneMapName()); }
-            break;
-          case MapStorage::SpecMapSaveOpts::TWO_MAPS:
-            { x("node_coords_save_dest", string("nodeset_sect_2_maps")); }
-            { x("map1_name", mapstorage->getNodeCoordsTwoMaps1Name()); }
-            { x("map2_name", mapstorage->getNodeCoordsTwoMaps2Name()); }
-            break;
-        }
-        break;
-    }
-  }
-
-  {
-    switch (mapstorage->getArrowCoordsSaveDest())
-    {
-      case MapStorage::SpecMapSaveOpts::GUI_SECT:
-        { x("arrow_coords_save_dest", string("gui_sect")); }
-        // write the arrow coorinates
-        {
-          const MapStorage::EdgeLabelMap& labels =
-            mapstorage->getEdgeLabelMap();
-          std::map<int, XY> arrow_coord_map;
-          MapStorage::ArrowCoordMap& map = mapstorage->getArrowCoordMap();
-          for (EdgeIt e(mapstorage->getGraph()); e != INVALID; ++e)
-          {
-            arrow_coord_map[labels[e]] = map[e];
-          }
-          { x("arrow_coord_map", arrow_coord_map); }
-        }
-        break;
-      case MapStorage::SpecMapSaveOpts::NESET_SECT:
-        switch (mapstorage->getArrowCoordsSaveMapNum())
-        {
-          case MapStorage::SpecMapSaveOpts::ONE_MAP:
-            { x("arrow_coords_save_dest", string("edgeset_sect_1_map")); }
-            { x("map_name", mapstorage->getArrowCoordsOneMapName()); }
-            break;
-          case MapStorage::SpecMapSaveOpts::TWO_MAPS:
-            { x("arrow_coords_save_dest", string("edgeset_sect_2_maps")); }
-            { x("map1_name", mapstorage->getArrowCoordsTwoMaps1Name()); }
-            { x("map2_name", mapstorage->getArrowCoordsTwoMaps2Name()); }
-            break;
-        }
-        break;
-    }
-  }
-
+  x("arrow_pos", m);
 
   std::map<int, std::string> nm;
@@ -252,5 +44,5 @@
       nm[i]=mapstorage->active_nodemaps[i];
     }
-  { x("active_nodemaps", nm); }
+  x("active_nodemaps", nm);
 
   std::map<int, std::string> em;
@@ -259,5 +51,5 @@
       em[i]=mapstorage->active_edgemaps[i];
     }
-  { x("active_edgemaps", em); }
+  x("active_edgemaps", em);
 
   double attraction;
@@ -267,12 +59,10 @@
   mapstorage->get_design_data(attraction, propulsation, iteration);
 
-  { x("redesign-attraction", attraction); }
-  { x("redesign-propulsation", propulsation); }
-  { x("redesign-iteration", iteration); }
+  x("redesign-attraction", attraction);
+  x("redesign-propulsation", propulsation);
+  x("redesign-iteration", iteration);
 }
 
-GuiWriter::GuiWriter(LemonWriter& writer, MapStorage* ms) :
-  Parent(writer),
-  mapstorage(ms)
+GuiWriter::GuiWriter(LemonWriter& writer, MapStorage* ms) : Parent(writer), mapstorage(ms)
 {
 }
Index: gui_writer.h
===================================================================
--- gui_writer.h	(revision 194)
+++ gui_writer.h	(revision 174)
@@ -20,7 +20,6 @@
 #define GUI_WRITER_H
 
+#include "mapstorage.h"
 #include <lemon/lemon_writer.h>
-
-class MapStorage;
 
 using lemon::LemonWriter;
